﻿local HouseAddition = foundation.createMod();

-- Check the game version
_minimalGameVersionExpected = "1.8"
if (foundation.getGameVersion == nil) or (version.cmp(foundation.getGameVersion(), _minimalGameVersionExpected) < 0) then
    HouseAddition:logError("HouseAddition: game version anterior to " .. _minimalGameVersionExpected)
    return
end
_scriptFolder = "scripts1.9"
_modelsFolder = "models1.9"
if (version.cmp(foundation.getGameVersion(), "1.9") < 0) then
    _scriptFolder = "scripts1.8"
    _modelsFolder = "models"
end
HouseAddition:msgBox("HouseAddition: game version" .. foundation.getGameVersion())

-- Set the mod major versions
_HomePrefix = "HOME_VJR_V4"

-- common functions
--    As the global functions are not transmit yet from dependencies, this file has to be duplicated in each mod
HouseAddition:dofile(_scriptFolder .. "/common.lua")

_NoSandbox = difficultyLevel(HouseAddition, "HouseAddition")

--    Soft dependencies checks
_flagCottage = checkVersion(HouseAddition, "HouseAddition", "Cottage Industries", "b18417a7-7fd1-439c-b5d0-f2f1aceb62a6", "1.0.4")
_flagVegetableFarms = foundation.isModLoaded("c8b63172-5b6d-45eb-9fab-a40c8ecd9947")

--    Common BuildingParts
HouseAddition:registerEnumValue ("BUILDING_PART_TYPE", "EXTENSION")
HouseAddition:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")

HouseAddition:dofile(_scriptFolder .. "/building.lua")
--HouseAddition:dofile(_scriptFolder .. "/newGate.lua", _HomePrefix)

-- Check the organic option
if not foundation.isModEnabled("a2cc9768-2cfb-4215-bc3c-1d2ee0ac5a05") then
    -- additions to the vanilla housing system
    HouseAddition:dofile(_scriptFolder .. "/random.lua")
end

-- Monument for manual setting 
HouseAddition:dofile(_scriptFolder .. "/monument.lua")
