local NewGate, NewGatePrefix = ...

function registerHouse(_nameFbx, _nameAsset, _buildingZone) 
    -- Apply building asset processor
    NewGate:registerAssetProcessor(_modelsFolder .. "/" .. _nameFbx .. ".fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })

-- Register default roof material
    NewGate:registerAssetId(_modelsFolder .. "/" .. _nameFbx .. ".fbx/Materials/roof", NewGatePrefix .. "_" .. _nameAsset .. "_DEFAULT_MATERIAL")

    -- Register core prefab nodes
    NewGate:registerAssetId(_modelsFolder .. "/" .. _nameFbx .. ".fbx/Prefab/NewGate/" .. _nameFbx .. "Part", NewGatePrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register buildingPart for building the function
    NewGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = NewGatePrefix .. "_" .. _nameAsset .. "_PART",
	Category = "CORE",
	BuildingZone = _buildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = NewGatePrefix .. "_" .. _nameAsset .. "_PREFAB"
	},
    })

    -- Register the new gate Core part
    function registerHouseLevel(_level)
    NewGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = NewGatePrefix .. "_LVL" .. _level .. "_" .. _nameAsset .. "_PART",
	Name = NewGatePrefix .. "_" .. _nameAsset .. "_NAME",
	Description = NewGatePrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "CORE",
	BuildingZone = _buildingZone,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = NewGatePrefix .. "_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = _NoSandbox*1 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = _NoSandbox*10 },
			{ Resource = "STONE", Quantity = _NoSandbox*10 },
		}}
	},
      VillagerCapacity = 5,
	AssetBuildingFunction = registerFunctionHouse(NewGatePrefix, _nameAsset, _level),

    })
    end
    registerHouseLevel("1")
    registerHouseLevel("2")

-- Doors grounded
    NewGate:registerPrefabComponent(_modelsFolder .. "/" .. _nameFbx .. ".fbx/Prefab/NewGate/" .. _nameFbx .. "Part/door1", {
	DataType = "COMP_GROUNDED"
    })
    NewGate:registerPrefabComponent(_modelsFolder .. "/" .. _nameFbx .. ".fbx/Prefab/NewGate/" .. _nameFbx .. "Part/door2", {
	DataType = "COMP_GROUNDED"
    })
    -- For the stairs
    NewGate:configurePrefabFlagList(_modelsFolder .. "/" .. _nameFbx .. ".fbx/Prefab/NewGate/" .. _nameFbx .. "Part/door1", { "PLATFORM" })
    NewGate:configurePrefabFlagList(_modelsFolder .. "/" .. _nameFbx .. ".fbx/Prefab/NewGate/" .. _nameFbx .. "Part/door2", { "PLATFORM" })

end

registerHouse( "NewGate", "NEW_GATE",
    { ZoneEntryList = {
            { Polygon = polygon.createRectangle( { 6, 10 }, { -3, 0 } ),
              Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } },
            { Polygon = polygon.createRectangle( { 5, 5 }, { 6.5, -1.5 } ),
              Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } },
    }})

