local HouseAddition = ...

HouseAddition:log("HouseAddition: organic mode set.")

-- Register an intermediate step for housing system
-- This step is necessary, as in this first step the housing system doesn't take into account the BuildingZone

-- Apply building asset processor
HouseAddition:registerAssetProcessor(_modelsFolder .. "/HomeAsb.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

HouseAddition:registerAssetId(_modelsFolder .. "/HomeAsb.fbx/Prefab/assemblyHouse/homePart", _HomePrefix .. "_HOME_ASB_PREFAB")

function registerRandomBuilding(_buildingAssetId)
    HouseAddition:registerAsset({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_ASB_" .. _buildingAssetId .. "_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
                CoreRandomBuildingPartList = { _HomePrefix .. "_HOME_ASB_PREFAB" },
                MandatoryBuildingPartList = {
                    { BuildingPart = _HomePrefix .. "_" .. _buildingAssetId .. "_PART" }
                }
	}
    })
end

registerRandomBuilding("HOME2")
registerRandomBuilding("HOME3")
registerRandomBuilding("HOME4")
registerRandomBuilding("HOME5")
registerRandomBuilding("HOME6")
registerRandomBuilding("HOME7")
registerRandomBuilding("HOME11")

-- Overrides the vanilla housing system

HouseAddition:overrideAsset({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    Action = "APPEND",
                    _HomePrefix .. "_ASB_HOME2_PART",
                }
	}
})

HouseAddition:overrideAsset({
    Id = "BUILDING_PART_HOUSING_SERF_DENSITY_2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    Action = "APPEND",
                    _HomePrefix .. "_ASB_HOME11_PART",
                    _HomePrefix .. "_ASB_HOME3_PART",
                    _HomePrefix .. "_ASB_HOME4_PART",
                }
	}
})

HouseAddition:overrideAsset({
    Id = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
                    Action = "APPEND",
                    _HomePrefix .. "_ASB_HOME5_PART",
                    _HomePrefix .. "_ASB_HOME6_PART",
                    _HomePrefix .. "_ASB_HOME7_PART",
                }
	}
})
